import axios from 'axios'
import router from '@/router/index.js'

const http = axios.create({ baseURL: import.meta.env.VITE_BASE_URL })
http.interceptors.request.use(
  (config) => config,
  (error) => Promise.reject(error),
)
http.interceptors.response.use(
  (response) => {
    return [null, response.data]
  },
  (error) => {
    let response = error.response
    if (response.status === 401) return router.push('/login')
    return [response.data, null]
  },
)

export default http
