package {{ cookiecutter.__mvn_package }}.config;

import cn.dev33.satoken.jwt.StpLogicJwtForMixin;
import cn.dev33.satoken.stp.StpLogic;
import {{ cookiecutter.__mvn_package }}.common.Constants;
import {{ cookiecutter.__mvn_package }}.web.SuperManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * (SaTokenConfigure) SaToken 配置.
 *
 * @author zweiandlen
 * @since 2024/7/3 上午11:15
 */
@Configuration
public class SaTokenConfig {

  /**
   * 组件配置.
   *
   * @param config 配置
   */
  @Autowired
  public void configSaToken(cn.dev33.satoken.config.SaTokenConfig config) {
    // Jwt 令牌
    config.setTokenName(Constants.TOKEN);
    config.setJwtSecretKey(Constants.JWT_KEY);
    // 允许同一账号同一登录
    config.setIsConcurrent(true);
    // 同时登录时用一块令牌
    config.setIsShare(true);
  }

  @Bean
  public StpLogic getStpLogicJwt() {
    // Jwt 混入业务字段
    return new StpLogicJwtForMixin();
  }

  @Bean(initMethod = "randomPassword")
  public SuperManager getSuperUser() {
    return new SuperManager();
  }
}
