package {{ cookiecutter.__mvn_package }}.enums;

import com.baomidou.mybatisplus.annotation.EnumValue;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.v3.oas.annotations.media.Schema;
import java.util.Arrays;
import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * (ELoggerType) 日志类型.
 *
 * @author zweiandlen
 * @since 2024/4/28 下午4:02
 */
@Schema(
    enumAsRef = true,
    description =
        """
    日志表，分类(type)

    0 - 数据变更
    """)
@Getter
@AllArgsConstructor
public enum LoggerType {
  DB_AUTO_CHANGE(0, "数据变更");

  @EnumValue private final int field;
  private final String description;

  /**
   * 创建枚举.
   *
   * @param field 值
   * @return 枚举
   */
  @JsonCreator
  public static LoggerType valueOf(int field) {
    return Arrays.stream(LoggerType.values())
        .filter(e -> e.field == field)
        .findFirst()
        .orElse(null);
  }

  @JsonValue
  public int getField() {
    return field;
  }
}
