package {{ cookiecutter.__mvn_package }}.enums;

import com.baomidou.mybatisplus.annotation.EnumValue;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.v3.oas.annotations.media.Schema;
import java.util.Arrays;
import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * (EStatus) 启用标识.
 *
 * @author zweiandlen
 * @since 2024/4/10 上午11:31
 */
@Schema(
    enumAsRef = true,
    description =
        """
    状态(status)

    0 - 启用
    1 - 禁用
    """)
@Getter
@AllArgsConstructor
public enum Status {
  ENABLE(0, "启用"),
  DISABLE(1, "禁用");

  @EnumValue private final int field;
  private final String description;

  /**
   * 创建枚举.
   *
   * @param field 值
   * @return 枚举
   */
  @JsonCreator
  public static Status valueOf(int field) {
    return Arrays.stream(Status.values())
        .filter(i -> i.getField() == field)
        .findFirst()
        .orElse(null);
  }

  @JsonValue
  public int getField() {
    return field;
  }
}
