package {{ cookiecutter.__mvn_package }}.mapper;

import {{ cookiecutter.__mvn_package }}.mapper.entity.AuthorityExcel;
import {{ cookiecutter.__mvn_package }}.rest.entity.Authority;
import java.util.List;
import org.dromara.hutool.core.text.StrUtil;
import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.Named;

/**
 * (AuthorityMapper)
 *
 * @author zweiandlen
 * @since 2025/4/22 09:12
 */
@Mapper
public interface AuthorityMapper {

  @Mapping(target = "type", source = "type", qualifiedByName = "toTypeStr")
  @Mapping(target = "status", source = "status", qualifiedByName = "toStatusStr")
  AuthorityExcel toExcel(Authority authority);

  List<AuthorityExcel> toExcel(List<Authority> authorities);

  @Mapping(target = "type", source = "type", qualifiedByName = "toTypeId")
  @Mapping(target = "status", source = "status", qualifiedByName = "toStatusId")
  @Mapping(target = "version", ignore = true)
  @Mapping(target = "deleteTime", ignore = true)
  @Mapping(target = "createTime", ignore = true)
  @Mapping(target = "updateTime", ignore = true)
  @Mapping(target = "createBy", ignore = true)
  @Mapping(target = "updateBy", ignore = true)
  @Mapping(target = "tenant", source = "tenant", defaultValue = "")
  Authority toEntiry(AuthorityExcel authority);

  List<Authority> toEntity(List<AuthorityExcel> authorities);

  /** 空字符串转化为null */
  default Long mapEmptyStr(String pk) {
    return StrUtil.isEmptyIfStr(pk) ? null : Long.parseLong(pk);
  }

  @Named("toTypeId")
  default Integer toTypeId(String type) {
    return switch (type) {
      case "接口" -> 0;
      case "菜单" -> 1;
      case "按钮" -> 2;
      default -> 0;
    };
  }

  @Named("toTypeStr")
  default String toTypeStr(Integer type) {
    return switch (type) {
      case 0 -> "接口";
      case 1 -> "菜单";
      case 2 -> "按钮";
      default -> "其他";
    };
  }

  @Named("toStatusId")
  default Integer toStatusId(String status) {
    return switch (status) {
      case "可用" -> 0;
      case "禁用" -> 1;
      default -> 0;
    };
  }

  @Named("toStatusStr")
  default String toStatusStr(Integer status) {
    return switch (status) {
      case 0 -> "可用";
      case 1 -> "禁用";
      default -> "其他";
    };
  }
}
