package {{ cookiecutter.__mvn_package }}.mapper;

import {{ cookiecutter.__mvn_package }}.mapper.entity.LoggerExcel;
import {{ cookiecutter.__mvn_package }}.rest.entity.Logger;
import java.time.OffsetDateTime;
import java.util.List;
import org.dromara.hutool.core.date.DatePattern;
import org.dromara.hutool.core.date.DateUtil;
import org.dromara.hutool.core.text.StrUtil;
import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.Named;

/**
 * (LoggerMapper)
 *
 * @author zweiandlen
 * @since 2025/4/15 14:30
 */
@Mapper
public interface LoggerMapper {

  @Mapping(target = "type", source = "type", qualifiedByName = "toTypeStr")
  LoggerExcel toExcel(Logger logger);

  List<LoggerExcel> toExcel(List<Logger> loggers);

  @Mapping(target = "type", source = "type", qualifiedByName = "toTypeId")
  @Mapping(target = "deleteTime", ignore = true)
  @Mapping(target = "createTime", ignore = true)
  @Mapping(target = "updateTime", ignore = true)
  @Mapping(target = "createBy", ignore = true)
  @Mapping(target = "updateBy", ignore = true)
  Logger toEntity(LoggerExcel loggerExcel);

  List<Logger> toEntity(List<LoggerExcel> loggerExcels);

  /** 空字符串转化为null */
  default Long mapEmptyStr(String pk) {
    return StrUtil.isEmptyIfStr(pk) ? null : Long.parseLong(pk);
  }

  /** 时间格式化 */
  default String mapTimer(OffsetDateTime time) {
    return DateUtil.format(time.toLocalDateTime(), DatePattern.CHINESE_DATE_TIME_PATTERN);
  }

  @Named("toTypeId")
  default Integer toTypeId(String type) {
    return switch (type) {
      case "数据变更自动日志" -> 0;
      default -> null;
    };
  }

  @Named("toTypeStr")
  default String toTypeStr(Integer type) {
    return switch (type) {
      case 0 -> "数据变更自动日志";
      default -> null;
    };
  }
}
