package {{ cookiecutter.__mvn_package }}.mapper;

import {{ cookiecutter.__mvn_package }}.mapper.entity.RoleExcel;
import {{ cookiecutter.__mvn_package }}.rest.entity.Role;
import java.util.List;
import org.dromara.hutool.core.text.StrUtil;
import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.Named;

/**
 * (RoleMapper)
 *
 * @author zweiandlen
 * @since 2025/4/22 09:29
 */
@Mapper
public interface RoleMapper {

  @Mapping(target = "status", source = "status", qualifiedByName = "toStatusStr")
  RoleExcel toExcel(Role role);

  List<RoleExcel> toExcel(List<Role> roles);

  @Mapping(target = "status", source = "status", qualifiedByName = "toStatusId")
  @Mapping(target = "version", ignore = true)
  @Mapping(target = "deleteTime", ignore = true)
  @Mapping(target = "createTime", ignore = true)
  @Mapping(target = "updateTime", ignore = true)
  @Mapping(target = "createBy", ignore = true)
  @Mapping(target = "updateBy", ignore = true)
  @Mapping(target = "tenant", source = "tenant", defaultValue = "")
  Role toEntity(RoleExcel excel);

  List<Role> toEntity(List<RoleExcel> excels);

  /** 空字符串转化为null */
  default Long mapEmptyStr(String pk) {
    return StrUtil.isEmptyIfStr(pk) ? null : Long.parseLong(pk);
  }

  @Named("toStatusId")
  default Integer toStatusId(String status) {
    return switch (status) {
      case "可用" -> 0;
      case "禁用" -> 1;
      default -> 0;
    };
  }

  @Named("toStatusStr")
  default String toStatusStr(Integer status) {
    return switch (status) {
      case 0 -> "可用";
      case 1 -> "禁用";
      default -> "其他";
    };
  }
}
