package {{ cookiecutter.__mvn_package }}.mapper;

import {{ cookiecutter.__mvn_package }}.mapper.entity.TenantExcel;
import {{ cookiecutter.__mvn_package }}.rest.entity.Tenant;
import java.util.List;
import org.dromara.hutool.core.text.StrUtil;
import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.Named;

/**
 * (TenantMapper)
 *
 * @author zweiandlen
 * @since 2025/3/31 10:59
 */
@Mapper
public interface TenantMapper {

  @Mapping(target = "type", source = "type", qualifiedByName = "toTypeStr")
  @Mapping(target = "status", source = "status", qualifiedByName = "toStatusStr")
  TenantExcel toExcel(Tenant tenant);

  List<TenantExcel> toExcel(List<Tenant> tenants);

  @Mapping(target = "type", source = "type", qualifiedByName = "toTypeId")
  @Mapping(target = "status", source = "status", qualifiedByName = "toStatusId")
  @Mapping(target = "version", ignore = true)
  @Mapping(target = "deleteTime", ignore = true)
  @Mapping(target = "createTime", ignore = true)
  @Mapping(target = "updateTime", ignore = true)
  @Mapping(target = "createBy", ignore = true)
  @Mapping(target = "updateBy", ignore = true)
  Tenant toEntity(TenantExcel excel);

  List<Tenant> toEntity(List<TenantExcel> excels);

  /** 空字符串转化为null */
  default Long mapEmptyStr(String pk) {
    return StrUtil.isEmptyIfStr(pk) ? null : Long.parseLong(pk);
  }

  @Named("toTypeId")
  default Integer toTypeId(String type) {
    return switch (type) {
      case "企业" -> 0;
      case "个人" -> 1;
      default -> 0;
    };
  }

  @Named("toTypeStr")
  default String toTypeStr(Integer type) {
    return switch (type) {
      case 0 -> "企业";
      case 1 -> "个人";
      default -> "其他";
    };
  }

  @Named("toStatusId")
  default Integer toStatusId(String status) {
    return switch (status) {
      case "可用" -> 0;
      case "禁用" -> 1;
      default -> 0;
    };
  }

  @Named("toStatusStr")
  default String toStatusStr(Integer status) {
    return switch (status) {
      case 0 -> "可用";
      case 1 -> "禁用";
      default -> "其他";
    };
  }
}
