package {{ cookiecutter.__mvn_package }}.module.manager;

import cn.dev33.satoken.stp.StpUtil;
import {{ cookiecutter.__mvn_package }}.rest.api.R;
import {{ cookiecutter.__mvn_package }}.service.OwnService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import jakarta.annotation.Resource;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * (AuthController) 管理接口.
 *
 * @author zweiandlen
 * @since 2024/7/5 上午11:32
 */
@Tag(name = "管理接口", description = "需要令牌")
@RestController
@RequestMapping("manager/own")
public class AuthController {

  @Resource OwnService ownService;

  /**
   * 拥有的角色及权限.
   *
   * @return 结果数据
   */
  @Operation(summary = "用户的角色及权限")
  @GetMapping("auths")
  public R ownAuths() {
    return R.ok(ownService.getOwnAuths(StpUtil.getLoginIdAsString()));
  }

  /**
   * 拥有的角色.
   *
   * @return 结果数据
   */
  @Operation(summary = "用户的角色")
  @GetMapping("roles")
  public R ownRoles() {
    return R.ok(ownService.getOwnRole(StpUtil.getLoginIdAsString()));
  }

  /**
   * 拥有的权限.
   *
   * @return 结果数据
   */
  @Operation(summary = "用户的权限")
  @GetMapping("authorities")
  public R ownAuthority() {
    return R.ok(ownService.getOwnAuthority(StpUtil.getLoginIdAsString()));
  }

  /**
   * 拥有的菜单.
   *
   * @return 结果数据
   */
  @Operation(summary = "用户的菜单")
  @GetMapping("menus")
  public R ownMenu() {
    return R.ok(ownService.getOwnMenus(StpUtil.getLoginIdAsString()));
  }

  /**
   * 拥有的按钮.
   *
   * @return 结果数据
   */
  @Operation(summary = "用户的按钮")
  @GetMapping("buttons")
  public R ownButton() {
    return R.ok(ownService.getOwnButtons(StpUtil.getLoginIdAsString()));
  }
}
