package {{ cookiecutter.__mvn_package }}.module.manager.request;

import io.swagger.v3.oas.annotations.media.Schema;
import jakarta.validation.constraints.NotBlank;
import lombok.Data;

/**
 * (AccountLogin) 登录请求体.
 *
 * @author zweiandlen
 * @since 2024/4/1 09:40
 */
@Data
public class AccountLogin {

  //  @Size(min = 3, max = 50, message = "登录名长度在3到50个字符之间")
  @Schema(description = "登录名，RSA加密")
  private String name;

  //  @Size(min = 8, max = 15, message = "手机号长度在8到15个字符之间")
  @Schema(description = "手机号，RSA加密")
  private String mobile;

  //  @Email(message = "邮箱格式错误")
  @Schema(description = "邮箱，RSA加密")
  private String email;

  @NotBlank(message = "登录密码不能为空")
  //  @Size(min = 6, max = 32, message = "登录密码长度在6到32个字符之间")
  @Schema(description = "登录密码，RSA加密")
  private String password;

  @NotBlank(message = "验证码不能为空")
  @Schema(description = "图形验证码")
  private String captcha;

  @NotBlank(message = "验证码回执不能为空")
  @Schema(description = "图形验证码回执")
  private String captchaId;
}
