package {{ cookiecutter.__mvn_package }}.module.manager.request;

import io.swagger.v3.oas.annotations.media.Schema;
import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.NotNull;
import jakarta.validation.constraints.Size;
import lombok.Data;

/**
 * (AccountPassword) 修改密码请求体.
 *
 * @author zweiandlen
 * @since 2024/4/1 09:17
 */
@Data
public class AccountPassword {

  @NotNull(message = "ID不能为空")
  @Schema(description = "ID")
  private long id;

  @NotBlank(message = "登录密码不能为空")
  @Size(min = 6, max = 32, message = "登录密码长度在6到32个字符之间")
  @Schema(description = "登录密码")
  private String password;
}
