/*
 * Copyright (c) 2011-2021, baomidou (jobob@qq.com).
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package {{ cookiecutter.__mvn_package }}.rest.api;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * REST API 通用控制器.
 *
 * @author hubin
 * @since 2018-06-08
 */
public class ApiController {

  protected final Logger logger = LoggerFactory.getLogger(this.getClass());

  /**
   * 请求成功.
   *
   * @param data 数据内容
   * @param <T> 对象泛型
   * @return ignore
   */
  protected <T> R<T> success(T data) {
    return R.ok(data);
  }

  /**
   * 请求失败.
   *
   * @param msg 提示内容
   * @return ignore
   */
  protected <T> R<T> failed(String msg) {
    return R.failed(msg);
  }

  /**
   * 请求失败.
   *
   * @param errorCode 请求错误码
   * @return ignore
   */
  protected <T> R<T> failed(ErrorCode errorCode) {
    return R.failed(errorCode);
  }
}
