package {{ cookiecutter.__mvn_package }}.rest.entity;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.Version;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.Serializable;
import java.time.OffsetDateTime;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.apache.ibatis.type.JdbcType;

/**
 * 权限表(Authority)表实体类.
 *
 * @author zweiandlen
 * @since 2024-07-03 17:49:34
 */
@Schema(description = "权限表")
@EqualsAndHashCode(callSuper = true)
@Data
public class Authority extends Model<Authority> {
  // ID
  @Schema(description = "ID", type = "string")
  @JsonSerialize(using = ToStringSerializer.class)
  private Long id;

  // 父节点
  @Schema(description = "父节点", type = "string")
  @JsonSerialize(using = ToStringSerializer.class)
  private Long parentId;

  // 名称
  @Schema(description = "名称")
  private String name;

  // 英文值
  @Schema(description = "英文值")
  private String value;

  // 路径
  @Schema(description = "路径")
  private String path;

  // 外部链接
  @Schema(description = "外部链接")
  private String link;

  // 类型(0:接口 1:菜单 2:按钮)
  @Schema(description = "类型(0:接口 1:菜单 2:按钮)")
  private Integer type;

  // 状态(0:可用 1:禁用)
  @Schema(description = "状态(0:可用 1:禁用)")
  private Integer status;

  // 描述
  @Schema(description = "描述")
  private String description;

  // 乐观锁
  @Schema(description = "乐观锁")
  @Version
  private Integer version;

  // 逻辑删除
  @Schema(description = "逻辑删除")
  @TableLogic
  private Long deleteTime;

  // 创建时间
  @Schema(description = "创建时间")
  @JsonProperty(access = JsonProperty.Access.READ_ONLY)
  {% if cookiecutter.platform == "postgis" -%}
  @TableField(fill = FieldFill.INSERT_UPDATE, jdbcType = JdbcType.OTHER)
  {% else %}
  @TableField(fill = FieldFill.INSERT_UPDATE, jdbcType = JdbcType.DATETIMEOFFSET)
  {% endif %}
  private OffsetDateTime createTime;

  // 修改时间
  @Schema(description = "修改时间")
  @JsonProperty(access = JsonProperty.Access.READ_ONLY)
  {% if cookiecutter.platform == "postgis" -%}
  @TableField(fill = FieldFill.INSERT_UPDATE, jdbcType = JdbcType.OTHER)
  {% else %}
  @TableField(fill = FieldFill.INSERT_UPDATE, jdbcType = JdbcType.DATETIMEOFFSET)
  {% endif %}
  private OffsetDateTime updateTime;

  // 创建人
  @Schema(description = "创建人")
  @JsonProperty(access = JsonProperty.Access.READ_ONLY)
  @TableField(fill = FieldFill.INSERT)
  private String createBy;

  // 修改人
  @Schema(description = "修改人")
  @JsonProperty(access = JsonProperty.Access.READ_ONLY)
  @TableField(fill = FieldFill.INSERT_UPDATE)
  private String updateBy;

  // 租户
  @Schema(description = "租户")
  private String tenant;

  /**
   * 获取主键值.
   *
   * @return 主键值
   */
  @Override
  public Serializable pkVal() {
    return this.id;
  }
}
