/*
 * Copyright (c) 2011-2021, baomidou (jobob@qq.com).
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package {{ cookiecutter.__mvn_package }}.rest.enums;

import {{ cookiecutter.__mvn_package }}.rest.api.ErrorCode;

/**
 * REST API 错误码.
 *
 * @author hubin
 * @since 2017-06-26
 */
public enum ApiErrorCode implements ErrorCode {
  /** 失败. */
  FAILED(-1, "操作失败"),
  /** 成功. */
  SUCCESS(0, "执行成功");

  private final long code;
  private final String msg;

  ApiErrorCode(final long code, final String msg) {
    this.code = code;
    this.msg = msg;
  }

  /**
   * 转换错误码.
   *
   * @param code 错误码
   * @return 错误枚举
   */
  public static ApiErrorCode fromCode(long code) {
    ApiErrorCode[] ecs = ApiErrorCode.values();
    for (ApiErrorCode ec : ecs) {
      if (ec.getCode() == code) {
        return ec;
      }
    }
    return SUCCESS;
  }

  @Override
  public long getCode() {
    return this.code;
  }

  @Override
  public String getMsg() {
    return this.msg;
  }

  @Override
  public String toString() {
    return String.format(" ErrorCode:{code=%s, msg=%s} ", this.code, this.msg);
  }
}
