/*
 * Copyright (c) 2011-2021, baomidou (jobob@qq.com).
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package {{ cookiecutter.__mvn_package }}.rest.exceptions;

import {{ cookiecutter.__mvn_package }}.rest.api.ErrorCode;
import java.io.Serial;

/**
 * REST API 请求异常类.
 *
 * @author hubin
 * @since 2017-06-26
 */
public class ApiException extends RuntimeException {

  @Serial private static final long serialVersionUID = -5885155226898287919L;

  /** 错误码. */
  private ErrorCode errorCode;

  public ApiException(ErrorCode errorCode) {
    super(errorCode.getMsg());
    this.errorCode = errorCode;
  }

  public ApiException(String message) {
    super(message);
  }

  public ApiException(Throwable cause) {
    super(cause);
  }

  public ApiException(String message, Throwable cause) {
    super(message, cause);
  }

  public ErrorCode getErrorCode() {
    return this.errorCode;
  }
}
