package {{ cookiecutter.__mvn_package }}.service;

/**
 * (CaptchaService) 验证码服务.
 *
 * @author zweiandlen
 * @since 2024/7/3 下午3:28
 */
public interface CaptchaService {

  /**
   * 生成图形验证码.
   *
   * @param objectId 唯一ID
   * @return 图形验证码
   */
  String getCodeById(String objectId);

  /**
   * 生成邮件验证码.
   *
   * @param objectId 唯一ID
   * @param email 邮箱地址
   * @return 唯一ID
   */
  String getCodeByEmail(String objectId, String email);

  /**
   * 生成短信验证码.
   *
   * @param objectId 唯一ID
   * @param mobile 手机号
   * @return 唯一ID
   */
  String getCodeBySms(String objectId, String mobile);

  /**
   * 校验验证码.
   *
   * @param objectId 唯一ID
   * @param code 验证码
   * @return 验证结果
   */
  Boolean checkCodeById(String objectId, String code);
}
