package {{ cookiecutter.__mvn_package }}.service;

import {{ cookiecutter.__mvn_package }}.rest.entity.Authority;
import java.util.List;

/**
 * (OwnService) 用户拥有资源.
 *
 * @author zweiandlen
 * @since 2024/4/1 15:15
 */
public interface OwnService {

  /**
   * 拥有的角色及权限.
   *
   * @param id 用户ID
   * @return 权限与角色值
   */
  List<String> getOwnAuths(String id);

  /**
   * 拥有的角色.
   *
   * @param id 用户ID
   * @return 角色值
   */
  List<String> getOwnRole(String id);

  /**
   * 拥有的权限.
   *
   * @param id 用户ID
   * @return 权限值
   */
  List<String> getOwnAuthority(String id);

  /**
   * 拥有的菜单.
   *
   * @param id 用户ID
   * @return 菜单列表
   */
  List<Authority> getOwnMenus(String id);

  /**
   * 拥有的按钮.
   *
   * @param id 用户ID
   * @return 按钮列表
   */
  List<Authority> getOwnButtons(String id);
}
