package {{ cookiecutter.__mvn_package }}.web;

import {{ cookiecutter.__mvn_package }}.rest.api.R;
import io.swagger.v3.oas.annotations.Operation;
import jakarta.servlet.RequestDispatcher;
import jakarta.servlet.http.HttpServletRequest;
import java.util.Map;
import lombok.extern.slf4j.Slf4j;
import org.dromara.hutool.core.bean.BeanUtil;
import org.dromara.hutool.core.text.StrUtil;
import org.springframework.boot.autoconfigure.web.ErrorProperties;
import org.springframework.boot.autoconfigure.web.servlet.error.BasicErrorController;
import org.springframework.boot.web.servlet.error.ErrorAttributes;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * (GlobalBasicError) 全局异常处理.
 *
 * @author zweiandlen
 * @since 2024/7/3 下午2:39
 */
@Slf4j
@RestController
public class GlobalBasicError extends BasicErrorController {
  public GlobalBasicError(ErrorAttributes errorAttributes) {
    super(errorAttributes, new ErrorProperties());
  }

  @Operation(hidden = true)
  @RequestMapping
  @Override
  public ResponseEntity<Map<String, Object>> error(HttpServletRequest request) {
    log.error("接口异常");
    HttpStatus status = this.getStatus(request);
    if (status == HttpStatus.NO_CONTENT) {
      return new ResponseEntity<>(status);
    }
    String message = StrUtil.toStringOrNull(request.getAttribute(RequestDispatcher.ERROR_MESSAGE));
    return new ResponseEntity<>(BeanUtil.beanToMap(R.failed(message)), status);
  }
}
