package {{ cookiecutter.__mvn_package }}.web;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.extension.plugins.handler.TenantLineHandler;
import {{ cookiecutter.__mvn_package }}.common.Constants;
import {{ cookiecutter.__mvn_package }}.utils.ThreadLocalUtil;
import java.util.ArrayList;
import net.sf.jsqlparser.expression.Expression;
import net.sf.jsqlparser.expression.StringValue;
import org.dromara.hutool.core.collection.CollUtil;
import org.dromara.hutool.core.collection.ListUtil;
import org.springframework.stereotype.Component;

/**
 * (OrgTenantLineHandler)
 *
 * @author zweiandlen
 * @since 2025/3/25 14:41
 */
@Component
public class OrgTenantLineHandler implements TenantLineHandler {

  @Override
  public Expression getTenantId() {
    return new StringValue(ThreadLocalUtil.getByKey(Constants.TENANT, StrUtil.EMPTY));
  }

  @Override
  public String getTenantIdColumn() {
    return Constants.TENANT;
  }

  @Override
  public boolean ignoreTable(String tableName) {
    // 以下表忽略
    ArrayList<String> tables = ListUtil.of("tenant", "message");
    return CollUtil.safeContains(tables, tableName);
  }
}
