package {{ cookiecutter.__mvn_package }}.web;

import cn.dev33.satoken.stp.StpInterface;
import {{ cookiecutter.__mvn_package }}.service.OwnService;
import jakarta.annotation.Resource;
import java.util.List;
import org.springframework.stereotype.Component;

/**
 * (StpInterfaceImpl) SaToken 角色与权限集成.
 *
 * @author zweiandlen
 * @since 2024/7/5 上午11:06
 */
@Component
public class StpInterfaceImpl implements StpInterface {

  @Resource SuperManager superManager;
  @Resource OwnService ownService;

  @Override
  public List<String> getPermissionList(Object loginId, String loginType) {
    // 超级管理员有所有权限
    if (superManager.isReal()) {
      return List.of("*");
    }
    return ownService.getOwnAuthority(String.valueOf(loginId));
  }

  @Override
  public List<String> getRoleList(Object loginId, String loginType) {
    return ownService.getOwnRole(String.valueOf(loginId));
  }
}
