package {{ cookiecutter.__mvn_package }}.web;

import cn.dev33.satoken.stp.StpUtil;
import cn.hutool.core.util.StrUtil;
import {{ cookiecutter.__mvn_package }}.common.Constants;
import lombok.Data;
import lombok.extern.slf4j.Slf4j;
import org.dromara.hutool.core.util.RandomUtil;
import org.springframework.beans.factory.annotation.Value;

/**
 * (Super) 超级管理员.
 *
 * @author zweiandlen
 * @since 2024/7/10 下午3:22
 */
@Slf4j
@Data
public class SuperManager {

  @Value("${spring.profiles.default:dev}")
  private String profile;

  private String username = Constants.SUPER_MANAGER;

  private String realName = "超级管理员";

  private String tenant = StrUtil.EMPTY;

  private String password;

  /** 随机密码. */
  public void randomPassword() {
    // 开发环境超级管理员设置默认密码
    this.password = StrUtil.equals(profile, "dev") ? "123456" : RandomUtil.randomString(12);
    log.info(">>> 超级管理员: {} 密码: {}", this.username, this.password);
  }

  /**
   * 判断是否超级管理员.
   *
   * @return 真假
   */
  public boolean isReal() {
    if (StpUtil.isLogin()) {
      return StpUtil.getLoginIdAsString().equals(this.username);
    } else {
      return false;
    }
  }
}
